#ifndef RPM_H
#define RPM_H
/*
**	$Id: rpm.h,v 1.5 1995/06/28 17:57:39 martin Exp $
*/
/*
**	parameterized rpm type isn\'t used in the current package.
**	put it in to track PLPlot.
*/

typedef float	rpmFloat;
typedef enum {rFloatT} rpmNumType;

/*
**	rpmBinary has to be able to carry strings occasionally.
*/
typedef enum {
    rHandle, rString, rNumbers, rCommand
} rpmArgType;

typedef struct {
    int		good;
    rpmNumType	vtype;
    rpmArgType	usedas;
    int		dynamic;	/* true if dim, v are known alloc 	*/
    int		dimens;
    int*	dim;
    int		space;		/* alloc\'d size in bytes 		*/
    rpmFloat*	v;		/* stored row-wise 			*/
    char*	hname;		/* NULL or static handle name 		*/
    char*	string;		/* non-handle string value		*/

} rpmBinary;
/*
**	library stuff we might need in a using package
*/
int Rpm_Init(Tcl_Interp* interp);

rpmBinary	rpmNewBinary(int ndim, int* dlist);
void		rpmFreeBinary(rpmBinary vB);
int 		rpmLength(rpmBinary r);

rpmBinary* 	rpmGetHandle(char* name);
int 		rpmDeleteHandle(char* name);
char* 		rpmAsHandle(char* name, rpmBinary vb);

rpmBinary 	rpmAtof(Tcl_Interp* interp, char* list);
#endif
