#include <stdlib.h>
#include <ctype.h>
#include <tcl.h>
#include <stdio.h>

#include "rpm-internal.h"

/*
**	rpm palette index-table index
*/
int rpmIndexSubCmd(ClientData dummy, Tcl_Interp* interp)
{
    rpmBinary p, ix, r;
    int i, j;
    int ni, np;

    ix = rpmPop();
    p = rpmPop();


    r = rpmDeepCopy(ix);

    np = rpmLength(p);
    ni = rpmLength(ix);
    for(i = 0; i < ni; i++) {
		j = (int) ix.v[i];
		if(j < 0)
			j = 0;
		else if(j >= np)
			j = np - 1;
		r.v[i] = p.v[j];
    }
    rpmPushB(r);
    rpmFreeBinary(p);
    rpmFreeBinary(ix);

    return TCL_OK;
}

/*
**	rpm vals preds select
*/
int rpmSelectSubCmd(ClientData dummy, Tcl_Interp* interp)
{
    rpmBinary p, pred, r;
    int i, j;
    int ni, np, nr;

    pred = rpmPop();
    p = rpmPop();

    np = rpmLength(p);
    ni = rpmLength(pred);

	if(np != ni)
		return rpmBadNews(interp, "select: args different size");

	nr = 0;
	for(i = 0; i < np; i++)
		if(pred.v[i] != 0)
			++nr;

    r = rpmNewBinaryD1(nr);

	nr = 0;
    for(i = 0; i < np; i++)
		if(pred.v[i] != 0)
			r.v[nr++] = p.v[i];

    rpmPushB(r);
    rpmFreeBinary(p);
    rpmFreeBinary(pred);

    return TCL_OK;
}

